//+------------------------------------------------------------------+
//|                              Copyright  2007, Derik Breytenbach |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Derik Breytenbach"

// MA Period
extern int     MA_period1=10;
extern int     MA_period2=80;
extern string  SMA="MA_MODE=0 Simple moving average"; 
extern string  EMA="MA_MODE=1 Exponential moving average";
extern string  SMMA="MA_MODE=2 Smoothed moving average" ;
extern string  LWMA="MA_MODE=3 Linear weighted moving average"; 
extern int     MA_MODE = 0;
extern int     stoploss = 1000;

// Number of lots traded
extern double  Lots=0.1;

// Define the magic number
extern int     Magic_number = 999;

int init ()
{
  return(0);
}

int deinit()
{
  return(0);
}    

// Subroutine to determine if the entry rules are met
void MA_Entry()
   {
   int ticket;  
   double MA11 = iMA(NULL, 0, MA_period1, 0, 0, PRICE_CLOSE, 1);
   double MA21 = iMA(NULL, 0, MA_period2, 0, 0, PRICE_CLOSE, 1); 
   double MA12 = iMA(NULL, 0, MA_period1, 0, 0, PRICE_CLOSE, 2);
   double MA22 = iMA(NULL, 0, MA_period2, 0, 0, PRICE_CLOSE, 2);   
   int   total;
   total = OrdersTotal();
   if(total>=2)
      {
      if(MA11>MA21 && MA12<MA22)
         {              
         ticket=OrderSend(Symbol(),OP_BUY,2*Lots,Ask,5,Ask-stoploss*Point,0,0,Magic_number,0,Green);
         return (0);
         }
      if(MA11<MA21 && MA12>MA22)
         {                      
         ticket=OrderSend(Symbol(),OP_SELL,2*Lots,Bid,5,Bid+stoploss*Point,0,0,Magic_number,0,Red);       
         return (0);
         }
      }  
   if(MA11>MA21 && MA12<MA22)
     {   
      ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,5,Ask-stoploss*Point,0,0,Magic_number,0,Green);
      }
   if(MA11<MA21 && MA12>MA22)
      {               
      ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,5,Bid+stoploss*Point,0,0,Magic_number,0,Red);
      }
   }   
   
void MA_Exit()
   {
   int   total;
   total = OrdersTotal();
   double MA11 = iMA(NULL, 0, MA_period1, 0, 0, PRICE_CLOSE, 1);
   double MA21 = iMA(NULL, 0, MA_period2, 0, 0, PRICE_CLOSE, 1); 
   double MA12 = iMA(NULL, 0, MA_period1, 0, 0, PRICE_CLOSE, 2);
   double MA22 = iMA(NULL, 0, MA_period2, 0, 0, PRICE_CLOSE, 2); 
   double Profit = 0; 
   if(AccountEquity( ) > AccountBalance( ) && ((MA11<MA21 && MA12>MA22) || (MA11>MA21 && MA12<MA22)))
      {
      for(int pos=0;pos<total;pos++)
         {
         OrderSelect(pos,SELECT_BY_POS,MODE_TRADES);
         if(OrderType()==OP_BUY)
            {              
            OrderClose(OrderTicket(),OrderLots(),Bid,5,CLR_NONE); 
            }
         if(OrderType()==OP_SELL)
            {                      
            OrderClose(OrderTicket(),OrderLots(),Ask,5,CLR_NONE);         
            }
         }
      }   
   if(total>0)
      {
      for(pos=0;pos<total;pos++)
         {
         OrderSelect(pos,SELECT_BY_POS,MODE_TRADES);
         if(OrderType()==OP_BUY && OrderMagicNumber()==Magic_number && OrderProfit()>0 && MA11<MA21 && MA12>MA22)
            {              
            OrderClose(OrderTicket(),OrderLots(),Bid,5,CLR_NONE); 
            }
         if(OrderType()==OP_SELL && OrderMagicNumber()==Magic_number && OrderProfit()>0 && MA11>MA21 && MA12<MA22)
            {                      
            OrderClose(OrderTicket(),OrderLots(),Ask,5,CLR_NONE);         
            }
         }
      }
   }   

bool NewBar()
   {   
   static datetime lastbar = 0;   
   datetime curbar = iTime(Symbol(),0,0);   
   if(lastbar!=curbar)   
      {      
      lastbar=curbar;      
      return (true);   
      }   
   else   
      {      
      return(false);   
      }
   }

int start()
{
   if (NewBar()==true)
   {
   if(AccountFreeMarginCheck(Symbol(),OP_BUY,Lots)<=0) return (0);
   MA_Exit();
   MA_Entry(); 
   } 
   return (0);
}




